program Conv
  use sep
  
  implicit none

  integer 				:: n1,n2,n3
  integer 				:: n1_aux,n2_aux,n3_aux
  real					:: d1,d2,d3
  real 					:: d1_aux,d2_aux,d3_aux
  real 					:: o1,o2,o3
  real 					:: o1_aux,o2_aux,o3_aux
  integer				:: i1, i2, i3, iver, test
  logical                               :: auxi,ver
  real					:: sig1, sig2, pi
  complex, dimension(:,:), allocatable	:: data, fcmpx, mcmpx

  call sep_init()

! ----- calling parameters -------

  call from_history ("n1", n1)
  call from_history ("d1", d1)
  call from_history ("o1", o1)

  call from_history ("n2", n2)
  call from_history ("d2", d2)
  call from_history ("o2", o2)

  call from_history ("n3", n3, 1)
  call from_history ("d3", d3, 1.0)
  call from_history ("o3", o3, 0.0)

  call to_history ("o1", o1)
  call to_history ("d1", d1)
  call to_history ("n1", n1)

  call to_history ("o2", o2)
  call to_history ("d2", d2)
  call to_history ("n2", n2)

  call to_history ("o3", o3)
  call to_history ("d3", d3)
  call to_history ("n3", n3)

  call to_history("verb", iver)
  call to_history("esize", 8)

  call sep_close ()
! ----- end calling parameters -------

! ----- allocating -------------

   
  if (allocated (data) ) deallocate (data)
  if (allocated (fcmpx) ) deallocate (fcmpx)
  if (allocated (mcmpx) ) deallocate (mcmpx)
   
if (ver) write(0,*) "Reserving space ..."

  allocate (data(n1,n2),  STAT=test)
	if(test /=0) call seperr("cant allocate data")
  allocate (fcmpx(n1,n2),  STAT=test)
	if(test /=0) call seperr("cant allocate fcmpx")
  allocate (mcmpx(n1,n2),  STAT=test)
	if(test /=0) call seperr("cant allocate mcmpx")

if (ver) write(0,*) "Done reserving space ..."

pi=3.14159265

call sep_read(fcmpx,"filter")


do i3=1,n3 !{

 call sep_read(data)

 mcmpx = data*fcmpx

 call sep_write(mcmpx)

end do !}

deallocate( data, STAT=test)
if (test /=0) call seperr("cant deallocate pdata")
deallocate( fcmpx, STAT=test)
if (test /=0) call seperr("cant deallocate fcmpx")
deallocate( mcmpx, STAT=test)
if (test /=0) call seperr("cant deallocate mcmpx")

if (ver) write(0,*) "all done"

call exit(0)
end program Conv
